// DeviceDiscoverer.java
// Modified by: Maria Kazandjieva, marykaz@hotmail.com, Summer 2005

// This class takes care of looking for remote Bluetooth devices


import javax.bluetooth.*;
import java.util.*;


public class DeviceDiscoverer implements DiscoveryListener {

	Coordinator zigbee;
	Vector remoteDevices = new Vector();

	DiscoveryAgent discoveryAgent;

	public DeviceDiscoverer(Coordinator zigbee) {
		this.zigbee = zigbee;
		try {
			LocalDevice localDevice = LocalDevice.getLocalDevice();
			discoveryAgent = localDevice.getDiscoveryAgent();

			zigbee.updateStatus("[coordinator:] LocalDevice properties: " + localDevice.getFriendlyName() + " (" + localDevice.getBluetoothAddress() + ")");
			zigbee.updateStatus("[coordinator:] Searching for Bluetooth devices in the vicinity...");
			discoveryAgent.startInquiry(DiscoveryAgent.GIAC, this);

		} catch(Exception e) {
			e.printStackTrace();
		}
	}



	public void deviceDiscovered(RemoteDevice remoteDevice, DeviceClass cod) {

		try{
	        remoteDevices.addElement(remoteDevice);
			zigbee.updateStatus("[coordinator:] New device discovered : "  + remoteDevice.getFriendlyName(true)+ " (" + remoteDevice.getBluetoothAddress() + ")" );

		} catch(Exception e){
			e.printStackTrace();
		}

	}


	public void inquiryCompleted(int discType) {
		String inqStatus = null;

		if (discType == DiscoveryListener.INQUIRY_COMPLETED) {
			inqStatus = "[coordinator:] Inquiry completed";
		} else if (discType == DiscoveryListener.INQUIRY_TERMINATED) {
			inqStatus = "[coordinator:] Inquiry terminated";
		} else if (discType == DiscoveryListener.INQUIRY_ERROR) {
			inqStatus = "[coordinator:] Inquiry error";
		}

		zigbee.updateStatus(inqStatus);



	}

    public void servicesDiscovered(int transID, ServiceRecord[] servRecord){}

    public void serviceSearchCompleted(int transID, int respCode) {}

}