// Location_Data.java
// Written by: Maria Kazandjieva, marykaz@hotmail.com, Summer 2005
// created 06/14/05

// Displays information about node location and data reading from the node (i.e. temperature)

/* This code is identical to the one in Location_Energy.java with the expection that instead of energy label, there is a data label that diplays temperature information.
To view additional comments refer to the Locatio_Energy.java file */


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.Rectangle.*;
import java.lang.*;
import java.text.*;
import javax.swing.border.*;
import java.util.Random;


public class Location_Data extends JFrame  implements ActionListener
{
	// declare and initialize variables

	private int numberNodes = Global.numberNodes;
	private Node[] nodes_array =Global.nodes_array;
	Node myNode;

	int[] x = new int[numberNodes];
	int[] y = new int[numberNodes];

	final int MAX = 100;
	Container c;
	JPanel dataPanel, energyPanel;
	CustomPanel displayPanel;
	JScrollPane scrollPane;
	JPanel xyPanel;
	JScrollPane xyPane;
	JLabel[] xyL = new JLabel[numberNodes];
	JFormattedTextField widthTA, heightTA;
	JLabel widthL, heightL, label1;
	JLabel[] nodeL, dataL;
	JButton goB;
	int w_unit, w;
	int h_unit, h;
	Border raisedetched = BorderFactory.createEtchedBorder(EtchedBorder.RAISED);


	public Location_Data() {

	super("Location of nodes/ Temperature Data");
	this.setLocation(325, 75);
	this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);

	c = getContentPane();

	xyPanel = new JPanel (new GridLayout(numberNodes,1));
	xyPanel.setBorder (raisedetched);

	for (int j=0; j<numberNodes; j++) {
		myNode = nodes_array[j];
		xyL[j] = new JLabel("Node " +(j+1)+ " at ("+ myNode.getX() + "," + myNode.getY() + ")" );
		xyPanel.add(xyL[j]);
	}

	xyPane = new JScrollPane(xyPanel);
	xyPane.setPreferredSize(new Dimension(130,420));
	c.add(xyPane, BorderLayout.EAST);


	nodeL = new JLabel [numberNodes];
	dataL = new JLabel [numberNodes];

	dataPanel = new JPanel (new GridLayout (numberNodes, 2));
	dataPanel.setBorder (raisedetched);

	for (int i =0; i<numberNodes; i++) {
		myNode = nodes_array[i];
		nodeL[i] = new JLabel ("Node " + (i+1));
		dataL[i] = new JLabel ("Temperature: " + myNode.getData());
		dataPanel.add(nodeL[i]);
		dataPanel.add(dataL[i]);
	}

	scrollPane = new JScrollPane(dataPanel);
	scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
      scrollPane.setPreferredSize(new Dimension(200, 100));

	dataPanel = new JPanel (new BorderLayout());
	dataPanel.setBorder(raisedetched);

	widthTA = new JFormattedTextField(new java.text.DecimalFormat("#####0"));
	widthTA.setColumns(5);
	widthTA.setText("100");
	heightTA = new JFormattedTextField(new java.text.DecimalFormat("#####0"));
	heightTA.setColumns(5);
	heightTA.setText("100");

	widthL = new JLabel ("Width: ");
	heightL = new JLabel ("Height: ");

	dataPanel = new JPanel();

	dataPanel.add(widthL);
	dataPanel.add(widthTA);
	dataPanel.add(heightL);
	dataPanel.add(heightTA);

	goB = new JButton ("Display nodes");
	goB.setSelected(true);
	goB.addActionListener(this);
	dataPanel.add(goB);

	c.add(dataPanel, BorderLayout.NORTH);
	c.add(scrollPane, BorderLayout.SOUTH);
	displayPanel = new CustomPanel();

	displayPanel.setBorder(raisedetched);
	c.add(displayPanel, BorderLayout.CENTER);



	JMenuBar menu = new JMenuBar();
	setJMenuBar (menu);
	JMenu fileMenu = new JMenu("File");

	JMenuItem home = new JMenuItem("Selection screen");
	home.addActionListener (new ActionListener() {
	public void actionPerformed (ActionEvent e)
	{
		new ChoiceScreen();
		setVisible(false);
	}
	}
	);
	fileMenu.add(home);

	JMenuItem exit = new JMenuItem ("Exit");

	exit.addActionListener (new ActionListener() {
	public void actionPerformed (ActionEvent e)
	{
		System.exit(0);
	}
	}
	);
	fileMenu.add(exit);

	menu.add(fileMenu);

	JMenu helpMenu = new JMenu ("Help");
	menu.add(helpMenu);
	JMenuItem about = new JMenuItem ("About...");
	about.addActionListener ( new ActionListener() {
		public void actionPerformed(ActionEvent e)
	{
	JOptionPane.showMessageDialog(Location_Data.this, "This application was created" + " in Summer 2005", "About", JOptionPane.INFORMATION_MESSAGE);
	}
	}
	);

	helpMenu.add(about);


	setSize (560,610);
	setResizable(false);
	show();
}

public void actionPerformed (ActionEvent e) {

	w = Integer.parseInt(widthTA.getText());
	h = Integer.parseInt(heightTA.getText());

	w_unit = 400/w;
	h_unit = 400/h;

	if (e.getSource() == goB) {
		for (int i=0; i<numberNodes; i++) {
			myNode = nodes_array[i];
			x[i] = myNode.getX();
			y[i] = myNode.getY();
		}
			displayPanel.draw(w_unit, h_unit,x, y, numberNodes);


	}
}

}