// RunServer.java
// Written by Maria Kazandjieva, marykaz@hotmail.com, Summer 2005

// This class has the methods that are called from the Server.java class.

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.microedition.io.*;
import java.io.*;
import java.lang.*;
import javax.bluetooth.*;
import java.net.*;

public class RunServer implements Runnable {

	// declare and initiate variables
	static DatagramSocket s;
	static DatagramPacket p;

	private int numberNodes;
	private Node[] nodes_array;

	Server server;

	private double[] data;
	private double[] energy;
	private int[] x;
	private int[] y;

	volatile boolean keepRunning=true;

	String alert = ""; // string to be send to the Linux PDA

// construct the object
	public RunServer (int numberNodes, double[] data, double[] energy, int[] x, int[] y,
					Server server){
		this.numberNodes = numberNodes;
		this.data = data;
		this.energy = energy;
		this.x = x;
		this.y =y;
		this.server = server;

	}

// override the run() method so that it calls the send() method
	public void run(){
		send();
	}

	public void send(){

		while(keepRunning){		// set up the server to run in a loop until stopped

			StreamConnection con = null;
			StreamConnectionNotifier streamConnectionNotifier = null;


			UUID uuid = new UUID("8821", true);

			String serviceURL = "btspp://localhost:" + uuid.toString() + ";name=DataTransfer";
			LocalDevice localDevice = null;
// set up a connection which has to be open ans where the Bluetooth device will wait for incoming connections

			try{
				try{

			localDevice = LocalDevice.getLocalDevice();
			streamConnectionNotifier = (StreamConnectionNotifier)Connector.open(serviceURL);

				}catch(Exception e){
					e.printStackTrace();
				}

			//
			// Add the service record to the SDDB and wait for a client to connect
			//

			con = streamConnectionNotifier.acceptAndOpen();
			server.updateStatus("[server:] Now connected to the remote Bluetooth device");

// open an input stream so that data can be received
			DataInputStream in = con.openDataInputStream();

			server.updateStatus("[server:] The output stream is now open to receive data");


			numberNodes = in.readInt();
			server.updateStatus("[server:] numberNodes was read");
			Global.numberNodes = numberNodes;
// initialize the data arrays after receiving the number of nodes
			data = new double[numberNodes];
			energy = new double[numberNodes];
			x = new int[numberNodes];
			y = new int[numberNodes];

			Global.nodes_array = new Node[numberNodes];

	// save data in arrays
			for (int i=0; i<numberNodes; i++) {
				data[i]=in.readDouble();
			}
			server.updateStatus("[server:] got Data");

			for (int i=0; i<numberNodes; i++) {
				energy[i]=in.readDouble();
			}
			server.updateStatus("[server:] got Energy");

			for (int i=0; i<numberNodes; i++) {
				x[i]=in.readInt();
			}
			server.updateStatus("[server:]got X-coordinate");

			for (int i=0; i<numberNodes; i++) {
				y[i]=in.readInt();
			}
			server.updateStatus("[server:]got Y-coordinate");

			server.updateStatus("[server:] All values from the data array were read");

			for (int j=0; j<numberNodes; j++){
				Node node = new Node (data[j], energy[j], x[j], y[j]);
				Global.nodes_array[j]=node;
			}

			alert = "data:" + Double.toString(data[0]) +
					" energy:" + Double.toString(energy[0]) + " x:" + Integer.toString(x[0])
					+ " y:" + Integer.toString(y[0]);

			try {
				// call the method that sends a string to the Linux PDA
				clientFunc(alert);
			} catch (Exception e)
			{
				System.out.println("Error");
			}

			server.updateStatus("[server:] The array of nodes was successfully created");

			try{
				Thread.sleep(100);
				}
			catch(Exception ee){
				ee.printStackTrace();
			}

	// close stream and connection after done
			in.close();
			con.close();

			}
			catch(IOException ioe){
				ioe.printStackTrace();
			}
	}
} // end of method

	// this method was written by Vinod
	// it uses UDP to send a string to the Linux iPAQ
	public static void clientFunc(String alert) throws IllegalArgumentException,
	                                                  InterruptedException,
	                                                  SocketException,
	                                                  UnknownHostException{
	   int id, sport; //client id, server ip and server port

	    //Hardcode input for client
	      String dip = "10.0.0.1";
	      String port = "5000";

	   //id = Integer.parseInt(argv[0]);
	  // StringTokenizer t = new StringTokenizer(argv[1], ".");

	   InetAddress daddr = InetAddress.getByName(dip);
	   sport = Integer.parseInt(port);
	   s = new DatagramSocket();
	   s.connect(daddr, sport);
	   byte[] msg = new byte[5000];//size of message client can send
	   System.out.print("Client Alert: "+alert);

	   msg = alert.getBytes();

	   p = new DatagramPacket(msg, msg.length,daddr,sport);
	   try
	   {
	        s.send(p);
	      /*  byte[] msg1 = new byte[5000];
	        p = new DatagramPacket(msg1, msg1.length);
	        s.receive(p);
	        String smsg = new String(p.getData(), 0, p.getLength());
	        System.out.println("Message from Server:"+smsg);
		   */
	   }
	   catch (IOException e)
	   {
	        System.err.println("Could Not Send to Server");
	   }

 }//end of function


// method that changes a volatile boolean variable which when false causes the server to stop running
	public void stop(){
		keepRunning = false;
	}


} // end of class